> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mrassistant.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Execute Tool

> Execute a tool.



## OpenAPI

````yaml https://api.mrassistant.ai/openapi.json post /tools/execute
openapi: 3.1.0
info:
  title: Backend - Multilingual Voice Agent System
  description: FastAPI backend for multilingual voice agents with tool use
  version: 1.0.0
servers: []
security: []
paths:
  /tools/execute:
    post:
      tags:
        - tools
      summary: Execute Tool
      description: Execute a tool.
      operationId: execute_tool_tools_execute_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/app__models__schemas__ToolExecuteRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                additionalProperties: true
                type: object
                title: Response Execute Tool Tools Execute Post
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    app__models__schemas__ToolExecuteRequest:
      properties:
        session_id:
          type: string
          format: uuid
          title: Session Id
        agent_id:
          type: string
          format: uuid
          title: Agent Id
        tool_key:
          type: string
          title: Tool Key
        idempotency_key:
          type: string
          title: Idempotency Key
        args:
          additionalProperties: true
          type: object
          title: Args
        connection_ref:
          anyOf:
            - type: string
            - type: 'null'
          title: Connection Ref
      type: object
      required:
        - session_id
        - agent_id
        - tool_key
        - idempotency_key
        - args
      title: ToolExecuteRequest
      description: Tool execute request model.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````